Index: /pjproject/trunk/pjlib-util/build/pjlib_util.vcproj
===================================================================
--- /pjproject/trunk/pjlib-util/build/pjlib_util.vcproj	(revision 1129)
+++ /pjproject/trunk/pjlib-util/build/pjlib_util.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjlib_util"
-	ProjectGUID="{FE07F272-AE7F-4549-9E9F-EF9B80CB1693}"
+	ProjectGUID="{D1823239-F34E-4134-8385-3C85FE23C7DD}"
 	RootNamespace="pjlib_util"
 	>
Index: /pjproject/trunk/pjlib/build/pjlib.vcproj
===================================================================
--- /pjproject/trunk/pjlib/build/pjlib.vcproj	(revision 1129)
+++ /pjproject/trunk/pjlib/build/pjlib.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjlib"
-	ProjectGUID="{DA0E03ED-53A7-4050-8A85-90541C5509F8}"
+	ProjectGUID="{5D0985B4-DAA1-42DB-BDB6-30C2409EAE14}"
 	RootNamespace="pjlib"
 	>
Index: /pjproject/trunk/pjmedia/build/pjmedia.vcproj
===================================================================
--- /pjproject/trunk/pjmedia/build/pjmedia.vcproj	(revision 1129)
+++ /pjproject/trunk/pjmedia/build/pjmedia.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjmedia"
-	ProjectGUID="{7FDE3880-A4AB-49E3-B439-EBEF0A0C7A65}"
+	ProjectGUID="{1434FE6C-89C6-4E13-8150-D5A4B1038AAA}"
 	RootNamespace="pjmedia"
 	>
Index: /pjproject/trunk/pjmedia/build/pjmedia_codec.vcproj
===================================================================
--- /pjproject/trunk/pjmedia/build/pjmedia_codec.vcproj	(revision 1129)
+++ /pjproject/trunk/pjmedia/build/pjmedia_codec.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjmedia_codec"
-	ProjectGUID="{855DC8C0-D3E9-4A2E-AE47-116605A7BC9B}"
+	ProjectGUID="{0545EB9B-CE7C-4EDC-86E8-FB46A8DC1236}"
 	>
 	<Platforms>
Index: /pjproject/trunk/pjsip-apps/build/pjsip_apps.dsw
===================================================================
--- /pjproject/trunk/pjsip-apps/build/pjsip_apps.dsw	(revision 1129)
+++ /pjproject/trunk/pjsip-apps/build/pjsip_apps.dsw	(revision 1130)
@@ -132,4 +132,7 @@
     Project_Dep_Name pjsua_lib
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjnath
+    End Project Dependency
 }}}
 
Index: /pjproject/trunk/pjsip-apps/build/pjsua.vcproj
===================================================================
--- /pjproject/trunk/pjsip-apps/build/pjsua.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip-apps/build/pjsua.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjsua"
-	ProjectGUID="{8310649E-A25E-4AF0-91E8-9E3CC659BB89}"
+	ProjectGUID="{19EBB464-60E7-47C5-96D8-E012B8CF3A41}"
 	RootNamespace="pjsua"
 	>
Index: /pjproject/trunk/pjsip-apps/build/sample_debug.vcproj
===================================================================
--- /pjproject/trunk/pjsip-apps/build/sample_debug.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip-apps/build/sample_debug.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="sample_debug"
-	ProjectGUID="{A0F1AA62-0F6F-420D-B09A-AC04B6862821}"
+	ProjectGUID="{E13CECAA-8A8E-48CC-841F-5C4B845F0ECB}"
 	RootNamespace="sample_debug"
 	>
Index: /pjproject/trunk/pjsip-apps/build/samples.vcproj
===================================================================
--- /pjproject/trunk/pjsip-apps/build/samples.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip-apps/build/samples.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="samples"
-	ProjectGUID="{E378A1FC-0C9C-4462-860F-7E60BC1BF84E}"
+	ProjectGUID="{3CE5B675-EF25-434E-8AC2-23F0D76D1719}"
 	RootNamespace="samples"
 	Keyword="MakeFileProj"
Index: /pjproject/trunk/pjsip/build/pjsip_core.vcproj
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_core.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip/build/pjsip_core.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjsip_core"
-	ProjectGUID="{2BB84911-C1B4-4747-B93D-36AA82CC5031}"
+	ProjectGUID="{98E41390-0F17-4501-BB27-B7A933D06806}"
 	>
 	<Platforms>
Index: /pjproject/trunk/pjsip/build/pjsip_simple.vcproj
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_simple.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip/build/pjsip_simple.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjsip_simple"
-	ProjectGUID="{4B5945CD-0CB3-49AA-A7FF-7612D93F82C0}"
+	ProjectGUID="{F40BFAB7-A013-4B6F-9AC4-676199004F0F}"
 	>
 	<Platforms>
Index: /pjproject/trunk/pjsip/build/pjsip_ua.vcproj
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_ua.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip/build/pjsip_ua.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjsip_ua"
-	ProjectGUID="{B8719FD5-E8A6-4A36-943C-891D07F5DD21}"
+	ProjectGUID="{5672ED37-5A78-4393-94D0-7CFED60DCC44}"
 	>
 	<Platforms>
Index: /pjproject/trunk/pjsip/build/pjsua_lib.vcproj
===================================================================
--- /pjproject/trunk/pjsip/build/pjsua_lib.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip/build/pjsua_lib.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="pjsua_lib"
-	ProjectGUID="{9CA0FDFB-2172-41FC-B7F1-5CE915EDCB37}"
+	ProjectGUID="{8D13F110-93F9-4AE7-A717-DF25111B05DA}"
 	RootNamespace="pjsua_lib"
 	>
Index: /pjproject/trunk/pjsip/build/test_pjsip.vcproj
===================================================================
--- /pjproject/trunk/pjsip/build/test_pjsip.vcproj	(revision 1129)
+++ /pjproject/trunk/pjsip/build/test_pjsip.vcproj	(revision 1130)
@@ -4,5 +4,5 @@
 	Version="8.00"
 	Name="test_pjsip"
-	ProjectGUID="{B3F7D4E9-702F-4EB4-ADA8-098D0A83D770}"
+	ProjectGUID="{AF5815F7-AACB-4798-8FBD-37BF18CAC15C}"
 	>
 	<Platforms>